indexing
	description: "[
			An ordered colection of edges beginning at a `start_node'.
			This is a PATH as a LINEAR structure so each item can be accessed 
			from start to finish
			This is to used by SIMPLE_PATH and GRAPH.
			]"
	instructions: "[
			]" 
	author: "Jimmy J. Johnson"
	date: "26 Feb 03"

class
	LINEAR_PATH [G -> SIMPLE_EDGE]
	
inherit
	
	ARRAYED_LIST [G]
		rename
			item as edge,
			make as list_make
		export
			{NONE}
				all
			{SIMPLE_PATH}
				extend
			{ANY}
				before
		end
		
	LINEAR [G]
		rename
			item as edge
		undefine
			index_of,
			is_equal,
			copy,
			has,
			occurrences,
			off,
			search
		end

create
	make
	
feature {NONE} -- Initialization
	
	make (n: INTEGER; a_node: like first_node) is
			-- Create an instance
		require
			valid_number_of_items: n >= 0
			node_exists: a_node /= Void
		do
			list_make (n)
			first_node := a_node
		end
		
feature -- Access

	first_node: SIMPLE_NODE
			-- Anchor for class
			-- Redefine to change types of nodes the path can hold.

	node: like first_node is
			-- Current node.
		require
			not_after: not after
		local
			c: CURSOR
			found: BOOLEAN
		do
			Result := first_node
			from
				start
			until
				exhausted or found
			loop
				Result := edge.other_node (Result)
				if c = cursor then
					found := True
				end
				forth
			end
		ensure
			valid_result: Result /= Void
			before_constraint: before implies Result = first_node
			after_constraint: after implies Result = last_node
		end

	last_node: like first_node is
			-- The last node in the path.
			-- Since an edge has a node at each end, this feature must start at
			-- the `first_node' and step through the `linear_representation' of
			-- the path choosing the `other_node' (from SIMPLE_EDGE) in order
			-- to descide which of the two nodes of the last edge to chose.
-- FIX ME!!!
	-- a better way would be to start at the last edge, pick a node, and compare it
	-- to the previouse edge.  At some point (sooner) a choice can be made. 
	-- ???  
	-- Think about this.
		local
			c: CURSOR
		do
			c := CURSOR
			Result := first_node
			from
				start
			until
				exhausted
			loop
				Result := edge.other_node (Result)
				forth
			end
			go_to (c)
		end

	previous_node: like first_node is
			-- Node from which the current edge should have come.
			-- Used mainly in invariant.
		require
			not_before: not before
		do
			Result := edge.other_node (node)
		end

feature -- Element change

	set_first_node (a_node: like first_node) is
			-- Change `first_node'
		require
			node_exists: a_node /= Void
		do
			first_node := a_node
		end
		
end -- class LINEAR_PATH
