indexing
	description: "[
			A SIMPLE_PATH whitch holds WEIGHTED_EDGE's.
			]"
	instructions: "[
			]" 
	author: "Jimmy J. Johnson"
	date: "27 Feb 03"

class
	WEIGHTED_PATH [E]
		-- A set of edges from a start node to a final node.
		
inherit
	
	SIMPLE_PATH
		redefine
			first_node,
			edge,
			cost
		end
 
creation
	make

feature -- Access

	edge: WEIGHTED_EDGE [E] is
			-- The last edge (because path is a stack) and anchor.
			-- To access other edges in path use `linear_representation'.
		do
			Result ?= Precursor {SIMPLE_PATH}
		end
		
	first_node: WEIGHTED_NODE [E]
			-- Node at which this path starts and anchor for class
			-- Redefine to change types of nodes the path can hold.
		
	cost: NUMERIC is
			-- Cost to travel the entire path.
			-- Returns INTEGER "0" if there are no edges in the path.
			-- If the type of the `value' features from the edges is
			-- not a NUMERIC then the result is the number of edges.
			-- If the value fields of the edges are numeric then
			-- the result is the sum of the values.
		local
			num: NUMERIC
			lin: LINEAR_PATH [like edge]
		do
			if is_empty then
					-- No edges so the path has zero cost to traverse.
				Result := 0
			else
				num ?= edge.cost
				if num /= Void then
						-- `value', from the edge (type E) is a numeric,
						-- therefore the cost can be calculated (summed).
						-- Only have to check the `edge' because all
						-- the edges in the list are the same.
					lin := linear_representation
					from 
						lin.start
						Result := num.zero
					until lin.exhausted
					loop
						num ?= lin.edge.cost
						check
							is_numeric: num /= Void	-- because `edge' was numeric
						end
						Result := Result + num
						lin.forth
					end
				else
					Result := count
				end
			end
		end
	
end -- class WEIGHTED_PATH [E]
